'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _icons = require('./icons.json');

var _icons2 = _interopRequireDefault(_icons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// this is basically a clone of "Feather Icons React", edited for Predix UI Icons.
// main difference is that this lib uses full svg markup
// so a regex is called to pull the viewBox attribute and use it.
// it defaults to 24x24, but px icons are not based on that grid.
// until all px icons are based on the same grid, 
// or another attribute is passed to describe which grid to use,
// this viewBox attribute needs to be passed accordingly.

var PxIcon = function (_Component) {
  _inherits(PxIcon, _Component);

  function PxIcon() {
    _classCallCheck(this, PxIcon);

    return _possibleConstructorReturn(this, (PxIcon.__proto__ || Object.getPrototypeOf(PxIcon)).apply(this, arguments));
  }

  _createClass(PxIcon, [{
    key: 'createMarkup',
    value: function createMarkup(markup, size) {
      // we arent sanitizing markup right now, bc DOMPurify does not like self-closing tags.
      // now do the weird thing for dangerouslySetInnerHTML
      return { __html: markup };
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          icon = _props.icon,
          size = _props.size,
          className = _props.className,
          otherProps = _objectWithoutProperties(_props, ['icon', 'size', 'className']);
      // make a "css class friendly" name for the icon (no colon)


      var classFriendlyText = icon.replace(':', '-');
      // take out "px-" from icon name if applicable.
      // this way, user can do both px-util:close and util:close
      var iconNoPx = icon.replace('px-', '');
      var iconMarkup = _icons2.default[iconNoPx];
      var insides = iconMarkup.replace(/<svg ([^>]+)>/, '').replace('</svg>', '');
      var viewBoxMatches = iconMarkup.match(/viewBox="([^"]+)"/);
      var viewBoxAttr = viewBoxMatches && viewBoxMatches.length > 0 ? viewBoxMatches[1] : '0 0 24 24';

      if (iconMarkup) {
        return _react2.default.createElement(
          'svg',
          _extends({
            width: size,
            height: size,
            viewBox: viewBoxAttr,
            className: 'px-icon icon-' + classFriendlyText + ' ' + className
          }, otherProps),
          _react2.default.createElement('g', { dangerouslySetInnerHTML: this.createMarkup(insides, size) })
        );
      }
      return null;
    }
  }]);

  return PxIcon;
}(_react.Component);

PxIcon.propTypes = {
  icon: _propTypes2.default.string.isRequired,
  size: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  className: _propTypes2.default.string
};

PxIcon.defaultProps = {
  size: 24,
  className: ''
};

exports.default = PxIcon;